Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time.field
Class RemainderDateTimeField

    java.lang.Object
      org.joda.time.DateTimeField
          org.joda.time.field.BaseDateTimeField
              org.joda.time.field.DecoratedDateTimeField
                  org.joda.time.field.RemainderDateTimeField

    public class RemainderDateTimeField

extends DecoratedDateTimeField

Counterpart remainder datetime field to `DividedDateTimeField`. The field's unit duration is unchanged, but the range duration is scaled accordingly.

RemainderDateTimeField is thread-safe and immutable.

Since:
  1.0
Author:
  Brian S O'Neill
See Also:
  `DividedDateTimeField`

Constructor Summary
`RemainderDateTimeField(DateTimeField field, DateTimeFieldType type, int divisor)` Constructor.
`RemainderDateTimeField(DividedDateTimeField dividedField)` Construct a RemainderDateTimeField that compliments the given DividedDateTimeField.
`RemainderDateTimeField(DividedDateTimeField dividedField, DateTimeFieldType type)` Construct a RemainderDateTimeField that compliments the given DividedDateTimeField.

Method Summary
`long` | `addWrapField(long instant, int amount)` Add the specified amount to the specified time instant, wrapping around within the remainder range if necessary.
`int` | `get(long instant)` Get the remainder from the specified time instant.
`int` | `getDivisor()` Returns the divisor applied, in the field's units.
`int` | `getMaximumValue()` Get the maximum value for the field, which is always one less than the divisor.
`int` | `getMinimumValue()` Get the minimum value for the field, which is always zero.
`DurationField` | `getRangeDurationField()` Returns a scaled version of the wrapped field's unit duration field.
`long` | `remainder(long instant)` Returns the fractional duration milliseconds of this field.
`long` | `roundCeiling(long instant)` Round to the highest whole unit of this field.
`long` | `roundFloor(long instant)` Round to the lowest whole unit of this field.
`long` | `roundHalfCeiling(long instant)` Round to the nearest whole unit of this field.
`long` | `roundHalfEven(long instant)` Round to the nearest whole unit of this field.
`long` | `roundHalfFloor(long instant)` Round to the nearest whole unit of this field.
`long` | `set(long instant, int value)` Set the specified amount of remainder units to the specified time instant.

Methods inherited from class org.joda.time.field.DecoratedDateTimeField
`getDurationField, getWrappedField, isLenient`

Methods inherited from class org.joda.time.field.BaseDateTimeField
`add, add, add, addWrapField, addWrapPartial, convertText, getAsShortText, getAsShortText, getAsShortText, getAsShortText, getAsShortText, getAsText, getAsText, getAsText, getAsText, getAsText, getDifference, getDifferenceAsLong, getLeapAmount, getLeapDurationField, getMaximumShortTextLength, getMaximumTextLength, getMaximumValue, getMaximumValue, getMaximumValue, getMinimumValue, getMinimumValue, getMinimumValue, getName, getType, isLeap, isSupported, set, set, set, set, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### RemainderDateTimeField

    public RemainderDateTimeField(DateTimeField field,
                                  DateTimeFieldType type,
                                  int divisor)

  Constructor.

  Parameters:
    `field` - the field to wrap, like "year()".
    `type` - the field type this field actually uses
    `divisor` - divisor, such as 100 years in a century
  Throws:
    `java.lang.IllegalArgumentException` - if divisor is less than two

### RemainderDateTimeField

    public RemainderDateTimeField(DividedDateTimeField dividedField)

  Construct a RemainderDateTimeField that compliments the given DividedDateTimeField.

  Parameters:
    `dividedField` - complimentary divided field, like "century()".

### RemainderDateTimeField

    public RemainderDateTimeField(DividedDateTimeField dividedField,
                                  DateTimeFieldType type)

  Construct a RemainderDateTimeField that compliments the given DividedDateTimeField.

  Parameters:
    `dividedField` - complimentary divided field, like "century()".
    `type` - the field type this field actually uses

Method Detail

### get

    public int get(long instant)

  Get the remainder from the specified time instant.

  Overrides:
    `get` in class `DecoratedDateTimeField`
  Parameters:
    `instant` - the time instant in millis to query.
  Returns:
    the remainder extracted from the input.

### addWrapField

    public long addWrapField(long instant,
                             int amount)

  Add the specified amount to the specified time instant, wrapping around within the remainder range if necessary. The amount added may be negative.

  Overrides:
    `addWrapField` in class `BaseDateTimeField`
  Parameters:
    `instant` - the time instant in millis to update.
    `amount` - the amount to add (can be negative).
  Returns:
    the updated time instant.

### set

    public long set(long instant,
                    int value)

  Set the specified amount of remainder units to the specified time instant.

  Overrides:
    `set` in class `DecoratedDateTimeField`
  Parameters:
    `instant` - the time instant in millis to update.
    `value` - value of remainder units to set.
  Returns:
    the updated time instant.
  Throws:
    `java.lang.IllegalArgumentException` - if value is too large or too small.

### getRangeDurationField

    public DurationField getRangeDurationField()

  Returns a scaled version of the wrapped field's unit duration field.

  Overrides:
    `getRangeDurationField` in class `DecoratedDateTimeField`
  Returns:
    the range duration of this field, or null if field has no range

### getMinimumValue

    public int getMinimumValue()

  Get the minimum value for the field, which is always zero.

  Overrides:
    `getMinimumValue` in class `DecoratedDateTimeField`
  Returns:
    the minimum value of zero.

### getMaximumValue

    public int getMaximumValue()

  Get the maximum value for the field, which is always one less than the divisor.

  Overrides:
    `getMaximumValue` in class `DecoratedDateTimeField`
  Returns:
    the maximum value

### roundFloor

    public long roundFloor(long instant)

  Description copied from class: `BaseDateTimeField`
  Round to the lowest whole unit of this field. After rounding, the value of this field and all fields of a higher magnitude are retained. The fractional millis that cannot be expressed in whole increments of this field are set to minimum.

  For example, a datetime of 2002-11-02T23:34:56.789, rounded to the lowest whole hour is 2002-11-02T23:00:00.000.

  Overrides:
    `roundFloor` in class `DecoratedDateTimeField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundCeiling

    public long roundCeiling(long instant)

  Description copied from class: `BaseDateTimeField`
  Round to the highest whole unit of this field. The value of this field and all fields of a higher magnitude may be incremented in order to achieve this result. The fractional millis that cannot be expressed in whole increments of this field are set to minimum.

  For example, a datetime of 2002-11-02T23:34:56.789, rounded to the highest whole hour is 2002-11-03T00:00:00.000.

  The default implementation calls roundFloor, and if the instant is modified as a result, adds one field unit. Subclasses are encouraged to provide a more efficient implementation.

  Overrides:
    `roundCeiling` in class `BaseDateTimeField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundHalfFloor

    public long roundHalfFloor(long instant)

  Description copied from class: `BaseDateTimeField`
  Round to the nearest whole unit of this field. If the given millisecond value is closer to the floor or is exactly halfway, this function behaves like roundFloor. If the millisecond value is closer to the ceiling, this function behaves like roundCeiling.

  Overrides:
    `roundHalfFloor` in class `BaseDateTimeField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundHalfCeiling

    public long roundHalfCeiling(long instant)

  Description copied from class: `BaseDateTimeField`
  Round to the nearest whole unit of this field. If the given millisecond value is closer to the floor, this function behaves like roundFloor. If the millisecond value is closer to the ceiling or is exactly halfway, this function behaves like roundCeiling.

  Overrides:
    `roundHalfCeiling` in class `BaseDateTimeField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### roundHalfEven

    public long roundHalfEven(long instant)

  Description copied from class: `BaseDateTimeField`
  Round to the nearest whole unit of this field. If the given millisecond value is closer to the floor, this function behaves like roundFloor. If the millisecond value is closer to the ceiling, this function behaves like roundCeiling.

  If the millisecond value is exactly halfway between the floor and ceiling, the ceiling is chosen over the floor only if it makes this field's value even.

  Overrides:
    `roundHalfEven` in class `BaseDateTimeField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to round
  Returns:
    rounded milliseconds

### remainder

    public long remainder(long instant)

  Description copied from class: `BaseDateTimeField`
  Returns the fractional duration milliseconds of this field. In other words, calling remainder returns the duration that roundFloor would subtract.

  For example, on a datetime of 2002-11-02T23:34:56.789, the remainder by hour is 34 minutes and 56.789 seconds.

  The default implementation computes `instant - roundFloor(instant)`. Subclasses are encouraged to provide a more efficient implementation.

  Overrides:
    `remainder` in class `BaseDateTimeField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to get the remainder
  Returns:
    remainder duration, in milliseconds

### getDivisor

    public int getDivisor()

  Returns the divisor applied, in the field's units.

  Returns:
    the divisor

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD